// D import file generated from 'src\core\sys\posix\sys\select.d'
module core.sys.posix.sys.select;
private 
{
    import core.sys.posix.config;
}
public 
{
    import core.stdc.time;
}
public 
{
    import core.sys.posix.sys.time;
}
public 
{
    import core.sys.posix.sys.types;
}
public 
{
    import core.sys.posix.signal;
}
extern (C) 
{
    version (linux)
{
    private 
{
    alias c_long __fd_mask;
    enum __NFDBITS = 8 * __fd_mask.sizeof;
    extern (D) 
{
    int __FDELT(int d)
{
return d / __NFDBITS;
}
}
    extern (D) 
{
    int __FDMASK(int d)
{
return cast(__fd_mask)1 << d % __NFDBITS;
}
}
}
    enum FD_SETSIZE = 1024;
    struct fd_set
{
    __fd_mask[FD_SETSIZE / __NFDBITS] fds_bits;
}
    extern (D) 
{
    void FD_CLR(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] &= ~__FDMASK(fd);
}
}
    extern (D) 
{
    int FD_ISSET(int fd, fd_set* fdset)
{
return fdset.fds_bits[__FDELT(fd)] & __FDMASK(fd);
}
}
    extern (D) 
{
    void FD_SET(int fd, fd_set* fdset)
{
fdset.fds_bits[__FDELT(fd)] |= __FDMASK(fd);
}
}
    extern (D) 
{
    void FD_ZERO(fd_set* fdset)
{
fdset.fds_bits[0..$] = 0;
}
}
    int pselect(int, fd_set*, fd_set*, fd_set*, in timespec*, in sigset_t*);
    int select(int, fd_set*, fd_set*, fd_set*, timeval*);
}
else
{
    version (OSX)
{
    private 
{
    enum uint __DARWIN_NBBY = 8;
    enum uint __DARWIN_NFDBITS = (int).sizeof * __DARWIN_NBBY;
}
    enum FD_SETSIZE = 1024;
    struct fd_set
{
    int[(FD_SETSIZE + (__DARWIN_NFDBITS - 1)) / __DARWIN_NFDBITS] fds_bits;
}
    extern (D) 
{
    void FD_CLR(int fd, fd_set* fdset)
{
fdset.fds_bits[fd / __DARWIN_NFDBITS] &= ~(1 << fd % __DARWIN_NFDBITS);
}
}
    extern (D) 
{
    int FD_ISSET(int fd, fd_set* fdset)
{
return fdset.fds_bits[fd / __DARWIN_NFDBITS] & 1 << fd % __DARWIN_NFDBITS;
}
}
    extern (D) 
{
    void FD_SET(int fd, fd_set* fdset)
{
fdset.fds_bits[fd / __DARWIN_NFDBITS] |= 1 << fd % __DARWIN_NFDBITS;
}
}
    extern (D) 
{
    void FD_ZERO(fd_set* fdset)
{
fdset.fds_bits[0..$] = 0;
}
}
    int pselect(int, fd_set*, fd_set*, fd_set*, in timespec*, in sigset_t*);
    int select(int, fd_set*, fd_set*, fd_set*, timeval*);
}
else
{
    version (freebsd)
{
    private 
{
    enum uint _NFDBITS = c_ulong.sizeof * 8;
}
    enum uint FD_SETSIZE = 1024;
    struct fd_set
{
    c_ulong[(FD_SETSIZE + (_NFDBITS - 1)) / _NFDBITS] fds_bits;
}
}
}
}
}
